build.sh 11 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307
  1. #!/bin/bash
  2. # (c) 2014-2016 Freifunk Hochstift <kontakt@hochstift.freifunk.net>
  3. #
  4. # This script builds the firmware by the environment variables given, the
  5. # first two being mandatory:
  6. #
  7. # BASE = Gluon Version (tag or commit, i.e. v2014.4)
  8. # BRANCH = Firmware Branch (stable/testing/experimental)
  9. # VERSION = the version tag (can only be empty if BRANCH=experimental)
  10. #
  11. # optional:
  12. # AUTOUPDATER = force Autoupdater Branch (stable/testing/experimental/off)
  13. # BROKEN = 0 (default) or 1, build the untested hardware model firmwares, too
  14. # BUILD_TS = build timestamp (format: %Y-%m-%d %H:%M:%S)
  15. # CLEAN = 'dirclean' to perform "make dirclean" before build or 'clean' to perform "make clean" (default: 'none')
  16. # KEY_DIR = specify directory for gluon-opkg-key
  17. # MAKEJOBS = number of compiler processes running in parallel (default: number of CPUs/Cores)
  18. # PRIORITY = determines the number of day a rollout phase should last at most
  19. # PUBLISH = 0 (default) or 1, publish firmware at the end
  20. # SITE_ID = specific site repository commit-id (leave blank to use HEAD)
  21. # TARGETS = a space separated list of target platforms (if unset, all platforms will be build)
  22. # VERBOSE = 0 (default) or 1, call the make commands with 'V=s' to see actual errors better
  23. # VERSIONS_DIR = specify directory for version files
  24. #
  25. ### includes
  26. . functions.sh
  27. ### static variables
  28. MY_DIR=$(dirname $0)
  29. MY_DIR=$(readlink -f "${MY_DIR}")
  30. DEFAULT_KEY_DIR="${MY_DIR}/opkg-keys"
  31. DEFAULT_VERSIONS_DIR="${MY_DIR}/versions"
  32. CODE_DIR="${MY_DIR}/src"
  33. GLUON_BUILD_DIR="${CODE_DIR}/build"
  34. SITE_DIR="${CODE_DIR}/site"
  35. PATCH_DIR="${SITE_DIR}/patches"
  36. OUTPUT_DIR="${MY_DIR}/output"
  37. IMAGE_DIR="${CODE_DIR}/output/images"
  38. MODULE_DIR="${CODE_DIR}/output/modules"
  39. MANIFEST_DIR="${CODE_DIR}/output/images/sysupgrade"
  40. SITE_GEN_SCRIPT="${CODE_DIR}/packages/ffho/ffho/ffho-site-generate/scripts/gen-site-conf.lua"
  41. SRV_URL="firmware.in.ffho.net"
  42. SRV_USER="firmware"
  43. SRV_PATH="/srv/firmware"
  44. BUILD_INFO_FILENAME="build-info.txt"
  45. SITE_REPO_URL="https://git.ffho.net/freifunkhochstift/ffho-site.git"
  46. LANG=C
  47. pushd ${MY_DIR} > /dev/null
  48. ### set reasonable defaults for unset environment variables
  49. [ -n "${AUTOUPDATER}" ] || AUTOUPDATER=${BRANCH}
  50. if [ -n "${BROKEN}" ]; then
  51. if [ "${BROKEN}" -eq "1" ]; then
  52. export BROKEN
  53. else
  54. unset BROKEN
  55. fi
  56. fi
  57. [ -n "${BUILD_TS}" ] || BUILD_TS=$(date +"%Y-%m-%d %H:%M:%S")
  58. [ -n "${CLEAN}" ] || CLEAN="none"
  59. if [ -n "${KEY_DIR}" ]; then
  60. KEY_DIR=$(readlink -f "${KEY_DIR}")
  61. else
  62. KEY_DIR="${DEFAULT_KEY_DIR}"
  63. fi
  64. [ -e "${KEY_DIR}" ] || mkdir -p ${KEY_DIR}
  65. [ "$?" -eq "0" ] || abort "Unable to create key directory: ${KEY_DIR}"
  66. if [ -n "${VERSIONS_DIR}" ]; then
  67. VERSIONS_DIR=$(readlink -f "${VERSIONS_DIR}")
  68. else
  69. VERSIONS_DIR="${DEFAULT_VERSIONS_DIR}"
  70. fi
  71. [ -e "${VERSIONS_DIR}" ] || mkdir -p ${VERSIONS_DIR}
  72. [ "$?" -eq "0" ] || abort "Unable to create versions directory: ${VERSIONS_DIR}"
  73. [ -n "${MAKEJOBS}" ] || MAKEJOBS=$(grep -c "^processor" /proc/cpuinfo)
  74. [ -n "${PRIORITY}" ] || PRIORITY=0
  75. [ -n "${PUBLISH}" ] || PUBLISH=0
  76. [ -n "${VERBOSE}" ] || VERBOSE=0
  77. MAKE_PARAM=""
  78. [ "${VERBOSE}" -eq "1" ] && MAKE_PARAM="${MAKE_PARAM} V=s"
  79. ### ERROR handling
  80. [ -n "${BASE}" ] || abort "Please specify BASE environment variable (Gluon, i.e. 'v2014.3' or commit-id)."
  81. [ -n "${BRANCH}" ] || abort "Please specify BRANCH environment variable."
  82. [ "${BRANCH}" == "experimental" -o "${BASE}" != "HEAD" ] || abort "HEAD is not an allowed BASE-identifier for non-experimental builds. Either use a tagged commit or the commit-SHA itself."
  83. [ -n "${VERSION}" -o "${BRANCH}" == "experimental" ] || abort "Please specify VERSION environment variable (not necessary for experimental branch)."
  84. [ "${BRANCH}" == "experimental" -o ! -r "${VERSIONS_DIR}/${VERSION}" ] || abort "There exists a version file for '${VERSION}' ... you are trying to do something really stupid, aren't you?"
  85. ### INIT /src IF NECESSARY
  86. if [ ! -d "${CODE_DIR}" ]; then
  87. info "Code directory does not exist yet - fetching Gluon ..."
  88. git clone https://github.com/freifunk-gluon/gluon.git "${CODE_DIR}"
  89. [ "$?" -eq "0" ] || abort "Failed to fetch Gluon repository."
  90. fi
  91. ### INIT /src/site IF NECESSARY
  92. if [ ! -d "${SITE_DIR}" ]; then
  93. info "Site repository does not exist, fetching it ..."
  94. git clone "${SITE_REPO_URL}" "${SITE_DIR}"
  95. [ "$?" -eq "0" ] || abort "Failed to fetch SITE repository."
  96. fi
  97. pushd ${CODE_DIR} > /dev/null
  98. ### CHECKOUT GLUON
  99. progress "Checking out GLUON '${BASE}' ..."
  100. # check if gluon got modified and bail out if necessary
  101. [ "$(git status --porcelain)" ] && abort "Local changes to peers directory. Cowardly refusing to update gluon repository." >&2
  102. git fetch
  103. git checkout -q ${BASE}
  104. [ "$?" -eq "0" ] || abort "Failed to checkout '${BASE}' gluon base version, mimimi." >&2
  105. git show-ref --verify --quiet refs/remotes/origin/${BASE}
  106. if [ "$?" -eq "0" ]; then
  107. git pull
  108. [ "$?" -eq "0" ] || abort "Failed to get newest '${BASE}' in gluon repository, mimimi."
  109. fi
  110. GLUON_COMMIT=$(git rev-list --max-count=1 HEAD)
  111. ### CHECKOUT SITE REPO
  112. progress "Checking out SITE REPO ..."
  113. pushd ${SITE_DIR} > /dev/null
  114. if [ $(git remote | wc -l) -ge "1" ]; then
  115. git fetch
  116. # TODO: check if site got modified locally and bail out if necessary
  117. if [ -z "${SITE_ID}" ]; then
  118. # no specific site given - get the most current one
  119. git checkout -q ${BRANCH}
  120. git branch -r | grep ${BRANCH} > /dev/null
  121. if [ "$?" -eq "0" ]; then
  122. git rebase
  123. [ "$?" -eq "0" ] || abort "Failed to get newest '${BRANCH}' in site repository, mimimi."
  124. fi
  125. else
  126. # fetch site repo updates
  127. git fetch || true
  128. # commit given - use this one
  129. git checkout -q ${SITE_ID}
  130. [ "$?" -eq "0" ] || abort "Failed to checkout requested site commit '${SITE_ID}', mimimi."
  131. fi
  132. fi
  133. SITE_COMMIT=$(git rev-list --max-count=1 HEAD)
  134. popd > /dev/null #${SITE_DIR}
  135. ### APPLY PATCHES TO GLUON
  136. progress "Applying Patches ..."
  137. git checkout -B patching "${BASE}"
  138. if [ -d "${PATCH_DIR}" -a "$(echo ${PATCH_DIR}/*.patch)" ]; then
  139. git am --whitespace=nowarn ${PATCH_DIR}/*.patch || (
  140. git am --abort
  141. git checkout patched
  142. git branch -D patching
  143. false
  144. )
  145. [ "$?" -eq "0" ] || abort "Failed to apply patches, mimimi."
  146. fi
  147. git branch -M patched
  148. ### DIRCLEAN
  149. if [ -d "${GLUON_BUILD_DIR}/" -a "${CLEAN}" == "dirclean" ]; then
  150. progress "Cleaning your build environment (make dirclean) ..."
  151. make dirclean
  152. fi
  153. ### PREPARE
  154. progress "Preparing the build environment (make update) ..."
  155. make update
  156. [ "$?" -eq "0" ] || abort "Failed to update the build environment, mimimi."
  157. popd > /dev/null #${CODE_DIR}
  158. ### set reasonable defaults for ${TARGETS} and ${BRANCH} if unset
  159. if [ -z "${TARGETS}" ]; then
  160. TARGETS=$(make list-targets | sed -e 's/^[[:space:]]*//' -e 's/[[:space:]]*$//')
  161. info "building all targets: '${TARGETS}'"
  162. fi
  163. if [ "${BRANCH}" == "experimental" -a -z "${VERSION}" ] ; then
  164. VERSION=$(make default-release)
  165. info "EXPERIMENTAL FIRMWARE: using version tag '${VERSION}'"
  166. fi
  167. # we are now ready to produce the firmware images, so let's "save" our state
  168. build_info_path="${VERSIONS_DIR}/${VERSION}"
  169. progress "Saving build information to: ${build_info_path}"
  170. [ -n "${build_info_path}" -a -f "${build_info_path}" ] && rm -f ${build_info_path}
  171. mkdir -p $(dirname ${build_info_path})
  172. [ "$?" -eq "0" ] || abort "Unable to create output directory: $(dirname ${build_info_path})"
  173. touch $(dirname ${build_info_path})
  174. [ "$?" -eq "0" ] || abort "Cannot create build information file: ${build_info_path}"
  175. echo "VERSION=${VERSION}" >> ${build_info_path}
  176. echo "GLUON=${GLUON_COMMIT} # ${BASE}" >> ${build_info_path}
  177. echo "BRANCH=${BRANCH}" >> ${build_info_path}
  178. echo "SITE=${SITE_COMMIT} # ${VERSION}" >> ${build_info_path}
  179. echo "TARGETS=${TARGETS}" >> ${build_info_path}
  180. echo "TS=${BUILD_TS}" >> ${build_info_path}
  181. ### restore gluon-opkg-key, if already exists
  182. if [ -e "${KEY_DIR}/gluon-opkg-key" -a -e "${KEY_DIR}/gluon-opkg-key.pub" ]; then
  183. info "gluon-opkg-key already exists, restoring it."
  184. mkdir -p ${GLUON_BUILD_DIR}/
  185. [ "$?" -eq "0" ] || abort "Unable to create directory: ${GLUON_BUILD_DIR}/"
  186. cp -f ${KEY_DIR}/gluon-opkg-key* ${GLUON_BUILD_DIR}/
  187. [ "$?" -eq "0" ] || abort "Unable to copy gluon-opkg-key."
  188. fi
  189. ### create site.conf
  190. if [ -x "${SITE_GEN_SCRIPT}" ]; then
  191. progress "Generating defaut site.conf"
  192. eval GLUON_SITEDIR=${SITE_DIR} ${SITE_GEN_SCRIPT}
  193. fi
  194. ### BUILD FIRMWARE
  195. progress "Building the firmware - please stand by!"
  196. pushd ${CODE_DIR} > /dev/null
  197. for target in ${TARGETS} ; do
  198. # configure build environment for our current target
  199. export GLUON_TARGET="${target}"
  200. export GLUON_RELEASE="${VERSION}"
  201. [ "${AUTOUPDATER}" != "off" ] && export GLUON_BRANCH="${AUTOUPDATER}"
  202. # prepare build environment for our current target
  203. progress "${target}: Preparing build environment."
  204. if [ "${CLEAN}" == "clean" ]; then
  205. make clean
  206. [ "$?" -eq "0" ] || abort "${target}: Unable to clean environment."
  207. fi
  208. make -j ${MAKEJOBS} prepare-target ${MAKE_PARAM}
  209. [ "$?" -eq "0" ] || abort "${target}: Unable to build environment."
  210. # need to have a toolchain for the particular target
  211. progress "${target}: Building toolchain."
  212. make -j ${MAKEJOBS} toolchain/install ${MAKE_PARAM}
  213. [ "$?" -eq "0" ] || abort "${target}: Unable to build toolchain."
  214. # now we can start building the images for the target platform
  215. progress "${target}: Building FFHO-flavoured Gluon firmware. You'd better go and fetch some c0ffee!"
  216. make -j ${MAKEJOBS} prepare ${MAKE_PARAM}
  217. [ "$?" -eq "0" ] || abort "${target}: Unable to build firmware."
  218. # finally compile the firmware binaries
  219. progress "${target}: Compiling binary firmware images."
  220. make -j ${MAKEJOBS} images ${MAKE_PARAM}
  221. [ "$?" -eq "0" ] || abort "${target}: Unable to assemble images."
  222. # compile the modules
  223. progress "${target}: Compiling modules."
  224. make -j ${MAKEJOBS} modules ${MAKE_PARAM}
  225. [ "$?" -eq "0" ] || abort "${target}: Unable to build modules."
  226. done
  227. # generate manifest
  228. progress "Generating manifest ..."
  229. GLUON_PRIORITY=${PRIORITY} GLUON_BRANCH=${BRANCH} make manifest
  230. [ "$?" -eq "0" ] || abort "Failed to generate the manifest."
  231. popd > /dev/null #${CODE_DIR}
  232. if [ "${PUBLISH}" -eq "1" ]; then
  233. # copying firmware to the server
  234. if [ -d "${IMAGE_DIR}" ]; then
  235. progress "Copying the firmware ..."
  236. rsync -rlutzc --exclude=*manifest -e ssh ${IMAGE_DIR}/ ${SRV_USER}@${SRV_URL}:${SRV_PATH}/${VERSION}
  237. [ "$?" -eq "0" ] || abort "Failed to copy the firmware."
  238. fi
  239. # copying modules to the server
  240. if [ -d "${MODULE_DIR}" ]; then
  241. progress "Copying the modules ..."
  242. rsync -rlutzc -e ssh ${MODULE_DIR}/gluon-ffho-${VERSION}/ ${SRV_USER}@${SRV_URL}:${SRV_PATH}/${VERSION}/modules
  243. [ "$?" -eq "0" ] || abort "Failed to copy the modules."
  244. fi
  245. # copy manifest and the build info file
  246. progress "Copying manifest and build info file ..."
  247. pushd ${OUTPUT_DIR} > /dev/null
  248. git fetch
  249. git checkout -q signing
  250. git merge --ff-only origin/master
  251. mkdir -p "${OUTPUT_DIR}/${VERSION}/sysupgrade"
  252. cp -f "${MANIFEST_DIR}/${BRANCH}.manifest" "${OUTPUT_DIR}/${VERSION}/sysupgrade/"
  253. cp -f "${build_info_path}" "${OUTPUT_DIR}/${VERSION}/${BUILD_INFO_FILENAME}"
  254. popd > /dev/null #${OUTPUT_DIR}
  255. # Update symlinks
  256. progress "Update symlink for ${BRANCH}"
  257. pushd ${OUTPUT_DIR} > /dev/null
  258. ln -fsn ${VERSION} ${BRANCH}
  259. popd > /dev/null #${OUTPUT_DIR}
  260. fi
  261. # Saving a copy of gluon-opkg-key
  262. [ -e "${KEY_DIR}/gluon-opkg-key" -a -e "${KEY_DIR}/gluon-opkg-key.pub" ] || cp ${GLUON_BUILD_DIR}/gluon-opkg-key* ${KEY_DIR}/
  263. [ "$?" -eq "0" ] || abort "Failed to save gluon-opkg-key, try to execute 'cp ${GLUON_BUILD_DIR}/gluon-opkg-key* ${KEY_DIR}/' manually"
  264. # The end. Finally.
  265. success "We're done, go and enjoy your new firmware (${VERSION})!"
  266. popd > /dev/null #${MY_DIR}